<script lang="ts">
    /**
     * The list of available buildings for construction
     */
    import { createEventDispatcher } from 'svelte'
    import { buildings } from '$utils/fieldContentFactory'
    import type Building from '$models/Building'
    import Section from '../DistrictPanel/Section.svelte'

    const dispatch = createEventDispatcher()
    const availableBuildings: { [title: string]: Building[] } = Object.values(buildings).reduce(
        (acc, building) => {
            if (building.name !== 'DistrictCouncil') {
                const instance = new building(null, null, null) as Building
                if (instance.isProduction()) {
                    acc['Production buildings'].push(instance)
                    return acc
                }

                if (instance.isStorage()) {
                    acc['Storage buildings'].push(instance)
                    return acc
                }

                acc.Others.push(instance)
            }
            return acc
        },
        {
            'Production buildings': [],
            'Storage buildings': [],
            Others: []
        }
    )
</script>

<div class="flex flex-col gap-y-4">
    {#each Object.keys(availableBuildings) as title, i}
        <Section {title} toggle={i === 0}>
            <div class="available">
                {#each availableBuildings[title] as building}
                    <div
                        class="square"
                        on:click={() => dispatch('newBuilding', building.constructor.name)}
                    >
                        <span>{building.name()}</span>
                    </div>
                {/each}
            </div>
        </Section>
    {/each}
</div>

<style lang="postcss">
    .available {
        @apply grid grid-cols-2 lg:grid-cols-3 gap-2 pt-1 pb-2;
    }

    .square {
        @apply relative flex items-center justify-center p-2 cursor-pointer
        transition-colors duration-150 ease-out
        bg-trueGray-200 dark:bg-trueGray-800 hover:bg-fuchsia-200 hover:dark:bg-fuchsia-900;
        aspect-ratio: 1;

        span {
            @apply text-center text-sm;
        }
    }
</style>
